# Carriers (Operations)

Endpoints to create, update and read carriers.

## GET /api/carriers

> List carriers

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers.","name":"Carriers (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"StrippedCarriers":{"properties":{"carriers":{"items":{"$ref":"#/components/schemas/StrippedCarrier"},"type":"array"},"total":{"description":"Total number of found entities for this query","type":"integer"}},"type":"object","title":"StrippedCarriers","description":"StrippedCarriers"},"StrippedCarrier":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"id":{"description":"The id of this carrier. It is generated during creation automatically and suits as the primary identifier of the described carrier.","type":"string"},"key":{"type":"string"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["id","name","key"],"type":"object"}],"xml":{"name":"StrippedCarrier"},"title":"StrippedCarrier","description":"StrippedCarrier"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"CarrierDeliveryType":{"description":"Provided delivery of this CEP. Default: DELIVERY","enum":["SAMEDAY","DELIVERY"],"type":"string","title":"CarrierDeliveryType"},"CarrierLifecycle":{"description":"Used to determine if a carrier is available for configuration. GA carriers are generally available and are covered by our SLA. BETA carriers are available, but subject to change and not covered by SLA. ALPHA carriers are not implemented completely, yet. Default: GA","enum":["GA","BETA","ALPHA"],"type":"string","title":"CarrierLifecycle"},"CarrierStatus":{"description":"It is taken into consideration for all carriers. Default: INACTIVE","enum":["ACTIVE","INACTIVE"],"type":"string","title":"CarrierStatus"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/carriers":{"get":{"description":"","operationId":"getCarriers","parameters":[{"description":"all entities after given Id","in":"query","name":"startAfterId","required":false,"schema":{"type":"string"}},{"description":"number of entities to show","in":"query","name":"size","required":false,"schema":{"default":25,"type":"integer"}},{"description":"Provide the localized names and descriptions for the parcel label classifications. If not provided the default locale is used., for example de_DE.","in":"query","name":"locale","schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StrippedCarriers"}}},"description":"The current list of available carriers"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"No more elements available"}},"summary":"List carriers","tags":["Carriers (Operations)"]}}}}
```

## POST /api/carriers

> Create carrier

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers.","name":"Carriers (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"CarrierForCreation":{"additionalProperties":false,"properties":{"credentials":{"$ref":"#/components/schemas/AbstractCarrierCredentials"},"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWeightInGram":{"default":1000,"description":"Default weight for a parcel in gram","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"key":{"description":"References the KEP. Currently allowed values are DHL_V2, DPD_CH, DPD_CH_VCE, ANGEL, GLS, FEDEX, POSTNL, BRING, UPS, POST_NORD, DHL_EXPRESS,\n CUSTOM and to distinct between multiple custom carriers one can use CUSTOM_ combined with a unique name.","type":"string"},"logoUrl":{"minLength":1,"type":"string"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassificationForCreation"},"type":"array"},"productValueNeeded":{"description":"Setting to enable the Client to ask for the parcel product value while ordering a label. This information is mandatory for sending parcels between different countries (customs declaration)","type":"boolean"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["name","key"],"type":"object","xml":{"name":"CarrierForCreation"},"title":"CarrierForCreation","description":"CarrierForCreation"},"AbstractCarrierCredentials":{"discriminator":{"propertyName":"key"},"properties":{"key":{"type":"string"}},"required":["key"],"type":"object","xml":{"name":"AbstractCarrierCredentials"},"title":"AbstractCarrierCredentials","description":"AbstractCarrierCredentials"},"ParcelLabelClassificationForCreation":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassificationForCreation","description":"ParcelLabelClassificationForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ParcelDimensions":{"additionalProperties":false,"nullable":true,"properties":{"customWeight":{"description":"Set this value if you want to overwrite the calculated weight of the parcel (in g).","type":"number"},"height":{"description":"The height of the package (in cm)","type":"number"},"length":{"description":"The length of the package (in cm)","type":"number"},"weight":{"description":"The weight of the package (in g)","type":"number"},"width":{"description":"The width of the package (in cm)","type":"number"}},"type":"object","title":"ParcelDimensions","description":"ParcelDimensions"},"ParcelLabelClassificationServices":{"additionalProperties":false,"properties":{"bulkyGoods":{"default":false,"type":"boolean"}},"type":"object","title":"ParcelLabelClassificationServices","description":"ParcelLabelClassificationServices"},"CarrierStatus":{"description":"It is taken into consideration for all carriers. Default: INACTIVE","enum":["ACTIVE","INACTIVE"],"type":"string","title":"CarrierStatus"},"Carrier":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/CarrierForCreation"},{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"id":{"description":"The id of the carrier","type":"string"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassification"},"type":"array"}},"required":["id","status","defaultParcelWidthInCm","defaultParcelLengthInCm","defaultParcelHeightInCm"],"type":"object"}],"xml":{"name":"Carrier"},"title":"Carrier","description":"Carrier"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"CarrierDeliveryType":{"description":"Provided delivery of this CEP. Default: DELIVERY","enum":["SAMEDAY","DELIVERY"],"type":"string","title":"CarrierDeliveryType"},"CarrierLifecycle":{"description":"Used to determine if a carrier is available for configuration. GA carriers are generally available and are covered by our SLA. BETA carriers are available, but subject to change and not covered by SLA. ALPHA carriers are not implemented completely, yet. Default: GA","enum":["GA","BETA","ALPHA"],"type":"string","title":"CarrierLifecycle"},"ParcelLabelClassification":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"name":{"description":"Name of the parcel label classification","type":"string"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassification","description":"ParcelLabelClassification"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/carriers":{"post":{"description":"","operationId":"addCarrier","parameters":[{"description":"Provide the localized names and descriptions for the parcel label classifications. If not provided the default locale is used., for example de_DE.","in":"query","name":"locale","schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CarrierForCreation"}}},"description":"Carrier object","required":true},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Carrier"}}},"description":"The carrier was successfully created. The Location header contains the URL of the carrier."},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Invalid input. See response for details"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"}},"summary":"Create carrier","tags":["Carriers (Operations)"]}}}}
```

## GET /api/carriers/{carrierId}

> Get carrier

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers.","name":"Carriers (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"Carrier":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/CarrierForCreation"},{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"id":{"description":"The id of the carrier","type":"string"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassification"},"type":"array"}},"required":["id","status","defaultParcelWidthInCm","defaultParcelLengthInCm","defaultParcelHeightInCm"],"type":"object"}],"xml":{"name":"Carrier"},"title":"Carrier","description":"Carrier"},"CarrierForCreation":{"additionalProperties":false,"properties":{"credentials":{"$ref":"#/components/schemas/AbstractCarrierCredentials"},"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWeightInGram":{"default":1000,"description":"Default weight for a parcel in gram","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"key":{"description":"References the KEP. Currently allowed values are DHL_V2, DPD_CH, DPD_CH_VCE, ANGEL, GLS, FEDEX, POSTNL, BRING, UPS, POST_NORD, DHL_EXPRESS,\n CUSTOM and to distinct between multiple custom carriers one can use CUSTOM_ combined with a unique name.","type":"string"},"logoUrl":{"minLength":1,"type":"string"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassificationForCreation"},"type":"array"},"productValueNeeded":{"description":"Setting to enable the Client to ask for the parcel product value while ordering a label. This information is mandatory for sending parcels between different countries (customs declaration)","type":"boolean"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["name","key"],"type":"object","xml":{"name":"CarrierForCreation"},"title":"CarrierForCreation","description":"CarrierForCreation"},"AbstractCarrierCredentials":{"discriminator":{"propertyName":"key"},"properties":{"key":{"type":"string"}},"required":["key"],"type":"object","xml":{"name":"AbstractCarrierCredentials"},"title":"AbstractCarrierCredentials","description":"AbstractCarrierCredentials"},"ParcelLabelClassificationForCreation":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassificationForCreation","description":"ParcelLabelClassificationForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ParcelDimensions":{"additionalProperties":false,"nullable":true,"properties":{"customWeight":{"description":"Set this value if you want to overwrite the calculated weight of the parcel (in g).","type":"number"},"height":{"description":"The height of the package (in cm)","type":"number"},"length":{"description":"The length of the package (in cm)","type":"number"},"weight":{"description":"The weight of the package (in g)","type":"number"},"width":{"description":"The width of the package (in cm)","type":"number"}},"type":"object","title":"ParcelDimensions","description":"ParcelDimensions"},"ParcelLabelClassificationServices":{"additionalProperties":false,"properties":{"bulkyGoods":{"default":false,"type":"boolean"}},"type":"object","title":"ParcelLabelClassificationServices","description":"ParcelLabelClassificationServices"},"CarrierStatus":{"description":"It is taken into consideration for all carriers. Default: INACTIVE","enum":["ACTIVE","INACTIVE"],"type":"string","title":"CarrierStatus"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"CarrierDeliveryType":{"description":"Provided delivery of this CEP. Default: DELIVERY","enum":["SAMEDAY","DELIVERY"],"type":"string","title":"CarrierDeliveryType"},"CarrierLifecycle":{"description":"Used to determine if a carrier is available for configuration. GA carriers are generally available and are covered by our SLA. BETA carriers are available, but subject to change and not covered by SLA. ALPHA carriers are not implemented completely, yet. Default: GA","enum":["GA","BETA","ALPHA"],"type":"string","title":"CarrierLifecycle"},"ParcelLabelClassification":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"name":{"description":"Name of the parcel label classification","type":"string"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassification","description":"ParcelLabelClassification"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/carriers/{carrierId}":{"get":{"description":"","operationId":"getCarrier","parameters":[{"description":"ID of the carrier you want to get","in":"path","name":"carrierId","required":true,"schema":{"type":"string"}},{"description":"Provide the localized names and descriptions for the parcel label classifications. If not provided the default locale is used., for example de_DE.","in":"query","name":"locale","schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Carrier"}}},"description":"Carrier was found & you were allowed to access it. The result is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"User not found"}},"summary":"Get carrier","tags":["Carriers (Operations)"]}}}}
```

## PATCH /api/carriers/{carrierId}

> Update carrier

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers.","name":"Carriers (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"CarrierPatchActions":{"properties":{"actions":{"items":{"$ref":"#/components/schemas/ModifyCarrier"},"minItems":1,"type":"array"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version","actions"],"type":"object","xml":{"name":"ShipmentPatchActions"},"title":"CarrierPatchActions","description":"CarrierPatchActions"},"ModifyCarrier":{"allOf":[{"$ref":"#/components/schemas/AbstractModificationAction"},{"additionalProperties":false,"properties":{"action":{"description":"Use value 'ModifyCarrierAction', because you want to modify a carrier","enum":["ModifyCarrier"],"type":"string"},"credentials":{"$ref":"#/components/schemas/AbstractModifyCarrierCredentials"},"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWeightInGram":{"default":1000,"description":"Default weight for a parcel in gram","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"logoUrl":{"minLength":1,"type":"string"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassificationForCreation"},"type":"array"},"productValueNeeded":{"description":"Setting to enable the Client to ask for the parcel product value while ordering a label. This information is mandatory for sending parcels between different countries (customs declaration)","type":"boolean"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["action"],"type":"object"}],"xml":{"name":"ModifyCarrier"},"title":"ModifyCarrier","description":"ModifyCarrier"},"AbstractModificationAction":{"discriminator":{"propertyName":"action"},"properties":{"action":{"description":"","enum":["AddAllowedValueToTag","ModifyPickJob","ModifyPickJobLastEditor","RestartPickJob","ResetPickJob","CancelPickRun","CancelHandoverjob","AbortPickJob","FinishPickRun","StartPickRun","ModifyPickLineItem","ModifyPickRunLineItem","ModifyPackJob","PausePackJob","ModifyPackLineItem","SplitLineItemsPackJob","ModifyFacility","ModifyListing","ModifyRetainedOfflineStock","ModifyListingReactivationAfter","ModifyUser","ModifyShipment","ModifyHandoverjob","ModifyCarrier","ModifyShortpick","ModifyRoutingPlan","ModifyFence","ModifyRating","ModifyTimingMode","ModifyGlobalRoutingConfiguration","ModifyOrderSplit","ModifyPrioritization","ModifyLoadUnitType","ModifyFeature","ModifyParcel","ModifyParcelLoadUnit","ModifyRestowItem","RemovePickJobFromPickRun","ModifyPartialStock","AddTagsToProcess","AssignFacilityToProcess","UpdateGdprCleanupDateAction","ModifyStorageLocation","ModifyPackingContainerType","ModifyPackingContainerTypeIcon","ReplaceCodesInPackingTargetContainer","ReplaceLoadUnitLineItems","AddLineItemToPackingTargetContainer","RemoveLineItemFromPackingTargetContainer","UpdateLineItemOnPackingTargetContainer","UpdatePackingTargetContainerLineItemRecordableAttributes","ModifyCustomService","UnlockOrder"],"type":"string"}},"required":["action"],"type":"object","xml":{"name":"AbstractModificationAction"},"title":"AbstractModificationAction","description":"AbstractModificationAction"},"AbstractModifyCarrierCredentials":{"discriminator":{"propertyName":"key"},"properties":{"key":{"type":"string"}},"required":["key"],"type":"object","xml":{"name":"AbstractModifyCarrierCredentials"},"title":"AbstractModifyCarrierCredentials","description":"AbstractModifyCarrierCredentials"},"CarrierDeliveryType":{"description":"Provided delivery of this CEP. Default: DELIVERY","enum":["SAMEDAY","DELIVERY"],"type":"string","title":"CarrierDeliveryType"},"CarrierLifecycle":{"description":"Used to determine if a carrier is available for configuration. GA carriers are generally available and are covered by our SLA. BETA carriers are available, but subject to change and not covered by SLA. ALPHA carriers are not implemented completely, yet. Default: GA","enum":["GA","BETA","ALPHA"],"type":"string","title":"CarrierLifecycle"},"ParcelLabelClassificationForCreation":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassificationForCreation","description":"ParcelLabelClassificationForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ParcelDimensions":{"additionalProperties":false,"nullable":true,"properties":{"customWeight":{"description":"Set this value if you want to overwrite the calculated weight of the parcel (in g).","type":"number"},"height":{"description":"The height of the package (in cm)","type":"number"},"length":{"description":"The length of the package (in cm)","type":"number"},"weight":{"description":"The weight of the package (in g)","type":"number"},"width":{"description":"The width of the package (in cm)","type":"number"}},"type":"object","title":"ParcelDimensions","description":"ParcelDimensions"},"ParcelLabelClassificationServices":{"additionalProperties":false,"properties":{"bulkyGoods":{"default":false,"type":"boolean"}},"type":"object","title":"ParcelLabelClassificationServices","description":"ParcelLabelClassificationServices"},"CarrierStatus":{"description":"It is taken into consideration for all carriers. Default: INACTIVE","enum":["ACTIVE","INACTIVE"],"type":"string","title":"CarrierStatus"},"Carrier":{"additionalProperties":false,"allOf":[{"$ref":"#/components/schemas/CarrierForCreation"},{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"deliveryType":{"$ref":"#/components/schemas/CarrierDeliveryType"},"id":{"description":"The id of the carrier","type":"string"},"lifecycle":{"$ref":"#/components/schemas/CarrierLifecycle"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassification"},"type":"array"}},"required":["id","status","defaultParcelWidthInCm","defaultParcelLengthInCm","defaultParcelHeightInCm"],"type":"object"}],"xml":{"name":"Carrier"},"title":"Carrier","description":"Carrier"},"CarrierForCreation":{"additionalProperties":false,"properties":{"credentials":{"$ref":"#/components/schemas/AbstractCarrierCredentials"},"defaultParcelHeightInCm":{"default":10,"description":"Default height in cm","minimum":1,"type":"number"},"defaultParcelLengthInCm":{"default":25,"description":"Default length in cm","minimum":1,"type":"number"},"defaultParcelWeightInGram":{"default":1000,"description":"Default weight for a parcel in gram","minimum":1,"type":"number"},"defaultParcelWidthInCm":{"default":35,"description":"Default width in cm","minimum":1,"type":"number"},"key":{"description":"References the KEP. Currently allowed values are DHL_V2, DPD_CH, DPD_CH_VCE, ANGEL, GLS, FEDEX, POSTNL, BRING, UPS, POST_NORD, DHL_EXPRESS,\n CUSTOM and to distinct between multiple custom carriers one can use CUSTOM_ combined with a unique name.","type":"string"},"logoUrl":{"minLength":1,"type":"string"},"name":{"description":"This is the well known name for a supported CEP partner. Can be adapted to the clients needs.","type":"string"},"parcelLabelClassifications":{"items":{"$ref":"#/components/schemas/ParcelLabelClassificationForCreation"},"type":"array"},"productValueNeeded":{"description":"Setting to enable the Client to ask for the parcel product value while ordering a label. This information is mandatory for sending parcels between different countries (customs declaration)","type":"boolean"},"status":{"$ref":"#/components/schemas/CarrierStatus"}},"required":["name","key"],"type":"object","xml":{"name":"CarrierForCreation"},"title":"CarrierForCreation","description":"CarrierForCreation"},"AbstractCarrierCredentials":{"discriminator":{"propertyName":"key"},"properties":{"key":{"type":"string"}},"required":["key"],"type":"object","xml":{"name":"AbstractCarrierCredentials"},"title":"AbstractCarrierCredentials","description":"AbstractCarrierCredentials"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"ParcelLabelClassification":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Localized name for parcel label classification"},"dimensions":{"$ref":"#/components/schemas/ParcelDimensions"},"name":{"description":"Name of the parcel label classification","type":"string"},"services":{"$ref":"#/components/schemas/ParcelLabelClassificationServices"}},"required":["nameLocalized","dimensions"],"type":"object","title":"ParcelLabelClassification","description":"ParcelLabelClassification"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/carriers/{carrierId}":{"patch":{"description":"","operationId":"patchCarrier","parameters":[{"description":"ID of carrier you want to patch","in":"path","name":"carrierId","required":true,"schema":{"type":"string"}},{"description":"Provide the localized names and descriptions for the parcel label classifications. If not provided the default locale is used., for example de_DE.","in":"query","name":"locale","schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CarrierPatchActions"}}},"description":"Patch set","required":true},"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Carrier"}}},"description":"Carrier was found & patch-set has been applied. The patched entity is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity not found"},"409":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity version conflict"}},"summary":"Update carrier","tags":["Carriers (Operations)"]}}}}
```

## Update transit time config

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update and read carriers.","name":"Carriers (Operations)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"TransitTimeConfigurationForUpsert":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"calculationStrategy":{"enum":["EARLIEST","LATEST"],"type":"string"}},"required":["calculationStrategy"],"type":"object","title":"TransitTimeConfigurationForUpsert","description":"TransitTimeConfigurationForUpsert"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"TransitTimeConfiguration":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"calculationStrategy":{"enum":["EARLIEST","LATEST"],"type":"string"},"id":{"type":"string"}},"required":["id","calculationStrategy"],"type":"object","title":"TransitTimeConfiguration","description":"TransitTimeConfiguration"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/configurations/transittime":{"put":{"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />","operationId":"putTransitTimeConfiguration","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/TransitTimeConfigurationForUpsert"}}},"required":true},"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/TransitTimeConfiguration"}}},"description":"Transit time configuration was written successfully"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Transit time configuration not found"}},"summary":"Update transit time config","tags":["Carriers (Operations)"]}}}}
```
